#include <Keypad.h>
#include <Servo.h>
#include <Adafruit_NeoPixel.h>
#define pinnum     11
#define pinnum2    12
#define num_LEDS  4

const byte keypadRows= 4;
const byte keypadCols= 4;

char keys[keypadRows][keypadCols]= 
{
{'1', '2', '3', 'A'}, 
{'4', '5', '6', 'B'}, 
{'7', '8', '9', 'C'},
{'*', '0', '#', 'D'}
};

byte therowpins[keypadRows] = {9,8,7,6};
byte thecolumnpins[keypadCols]= {5,4,3,2};

char keypadpressed;

Keypad oneKeypad= Keypad(makeKeymap(keys), therowpins, thecolumnpins, keypadRows, keypadCols);

Adafruit_NeoPixel neolightstrip1 = Adafruit_NeoPixel(num_LEDS, pinnum, NEO_GRB + NEO_KHZ800);

Adafruit_NeoPixel neolightstrip2 = Adafruit_NeoPixel(num_LEDS, pinnum2, NEO_GRB + NEO_KHZ800);

char securitycode[]= {'1','2','3','4'};

int a=0;
int i=0;
int j=0;

Servo doorarm;

void setup(){
  Serial.begin(9600);
  doorarm.attach(13);
  doorarm.write(0);
  pinMode(10, OUTPUT);
  neolightstrip1.begin();
  neolightstrip1.show();
  neolightstrip2.begin();
  neolightstrip2.show();
}

void loop(){
  keypadpressed = oneKeypad.getKey(); 
      ReadCode();
    		if(a==sizeof(securitycode)){
      			doorarm.write(180);
    		}
    		else{
              alarm();
  			}
}

void ReadCode(){ 
       i=0; 
       a=0;
       j=0; 
                                     
     while(keypadpressed != 'A'){                
           keypadpressed = oneKeypad.getKey();                       
       		if(keypadpressed != NO_KEY && keypadpressed != 'A' ){
              j++;
            if(keypadpressed == securitycode[i]&& i<sizeof(securitycode)){
                 a++;                                              
                 i++;
                 }
            else
                a--;     
            }
            }
    keypadpressed = NO_KEY;
}

void alarm(){
  for(int i=0;i<=1000;i++){
  		tone(10, 880, 200);
    	lightstrip1(neolightstrip1.Color(255, 0, 0));
    	tone(10, 880, 200);
    	lightstrip2(neolightstrip2.Color(255, 0, 0));
  }
}

void lightstrip1(uint32_t c) {
  	for(uint16_t i=0; i<neolightstrip1.numPixels()+4; i++) {
      neolightstrip1.setPixelColor(0, 255, 0, 0);
      neolightstrip1.setPixelColor(1, 255, 0, 0);
      neolightstrip1.setPixelColor(2, 255, 0, 0);
      neolightstrip1.setPixelColor(3, 255, 0, 0);
      neolightstrip1.show();
      delay(45);
      neolightstrip1.setPixelColor(0, 0, 0, 0);
      neolightstrip1.setPixelColor(1, 0, 0, 0);
      neolightstrip1.setPixelColor(2, 0, 0, 0);
      neolightstrip1.setPixelColor(3, 0, 0, 0);
      neolightstrip1.show();
  }
}


void lightstrip2(uint32_t c) {
  for(uint16_t i=0; i<neolightstrip2.numPixels()+4; i++) {
      neolightstrip2.setPixelColor(0, 255, 0, 0);
      neolightstrip2.setPixelColor(1, 255, 0, 0);
      neolightstrip2.setPixelColor(2, 255, 0, 0);
      neolightstrip2.setPixelColor(3, 255, 0, 0);
      neolightstrip2.show();
  	  delay(45);
      neolightstrip2.setPixelColor(0, 0, 0, 0);
      neolightstrip2.setPixelColor(1, 0, 0, 0);
      neolightstrip2.setPixelColor(2, 0, 0, 0);
      neolightstrip2.setPixelColor(3, 0, 0, 0);
      neolightstrip2.show();
  }
}

